#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <math.h>

using namespace std;

int main(int argn, char** argv)
{
    ifstream file;
    file.open("pair.txt");

    int pair_num = atoi(argv[1]);
    int** pair = new int*[pair_num];       
    for(int n = 0; n < pair_num; n ++)
    {
       pair[n] = new int[2];
       file >> pair[n][0] >> pair[n][1];
    }
    file.close();

    int spoint_num = atoi(argv[2]);
    int tpoint_num = atoi(argv[3]);
    double **points = new double*[spoint_num];
    file.open("points.txt");
    for(int n = 0; n < spoint_num; n ++)
    {
        points[n] = new double[2];
        file >> points[n][0] >> points[n][1];
    }
    file.close();

    double *areas = new double[spoint_num];
    file.open("areas.txt");
    for(int n = 0; n < spoint_num; n ++)
    {
        file >> areas[n];
    }
    file.close();

    double *areat = new double[tpoint_num];
    file.open("areat.txt");
    for(int n = 0; n < tpoint_num; n ++)
    {   
        file >> areat[n];
    }
    file.close();


    double** cost = new double*[spoint_num]; 
    int *cnum = new int[spoint_num];      
    for(int n = 0; n < spoint_num; n ++)
    {
       char str[100];
       sprintf(str, "cost%d.txt", n+1);
       file.open(str); 
       int clen;
       file >> clen;
       cnum[n] = clen;
       cost[n] = new double[clen];
       for(int m = 0; m < clen; m ++)
          file >> cost[n][m];
       file.close();
    }

    double*** pointt = new double**[spoint_num];
    int* pt_num = new int[spoint_num];       
    for(int n = 0; n < spoint_num; n ++)
    {       
       char str[100];
       sprintf(str, "pointt%d.txt", n+1);
       file.open(str); 
       int clen;
       file >> clen;
       pt_num[n] = clen;
       pointt[n] = new double*[clen];       
       for(int m = 0; m < clen; m ++)
       {
         pointt[n][m] = new double[2];
         file >> pointt[n][m][0] >> pointt[n][m][1];
       }
       file.close();
    }

    FILE *fd = fopen("binary.lp", "wt");
    fprintf(fd, "Minimize\n");

    for(int i = 0; i < spoint_num; i++)
    {
        for (int j = 0; j < cnum[i]; j++)
        {
            double cc = cost[i][j];
            fprintf(fd, "+%f yy%d,%d\n", cc, i+1, j+1);
        }
    }

   for(int p = 0; p < pair_num; p++)
    {
        fprintf(fd, "+%f p%d,%d + %f q%d,%d\n", 100.0, pair[p][0], pair[p][1], 100.0, pair[p][0], pair[p][1]);
        fprintf(fd, "+%f h%d,%d + %f g%d,%d\n", 100.0, pair[p][0], pair[p][1], 100.0, pair[p][0], pair[p][1]);
        fprintf(fd, "+%f u%d,%d + %f v%d,%d\n", 100.0, pair[p][0], pair[p][1], 100.0, pair[p][0], pair[p][1]);
        fprintf(fd, "+%f aa%d,%d + %f bb%d,%d\n",5.0, pair[p][0], pair[p][1], 5.0, pair[p][0], pair[p][1]);

   }
    
      
   fprintf(fd, "\n\nSubject To\n");
   for(int p = 0; p < pair_num; p++)
   {
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        for (int n = 0; n < cnum[j]; n++)
        {
             double a = atan2(pointt[i][m][1] - pointt[j][n][1],
                              pointt[i][m][0] - pointt[j][n][0]);
             double b = atan2(points[i][1] - points[j][1],
                              points[i][0] - points[j][0]);
             double c = cos(a - b);
            
             if (c > 0) 
                fprintf(fd, "+%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
             else if (c < 0)
                fprintf(fd, "%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
         }
        
         fprintf(fd, "- tt - p%d,%d + q%d,%d= 0\n", pair[p][0], pair[p][1], pair[p][0], pair[p][1]);
   }

   for(int p = 0; p < pair_num; p++)
   {
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        for (int n = 0; n < cnum[j]; n++)
        {
             double a = atan2(pointt[i][m][1] - pointt[j][n][1],
                              pointt[i][m][0] - pointt[j][n][0]);
             double b = atan2(points[i][1] - points[j][1],
                              points[i][0] - points[j][0]);
             double c = sin(a - b);
             
             if (c > 0)
                fprintf(fd, "+%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
             else if (c < 0)
                fprintf(fd, "%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
         }

         fprintf(fd, "- ww - h%d,%d + g%d,%d= 0\n", pair[p][0], pair[p][1], pair[p][0], pair[p][1]);
            
   }


   for(int p = 0; p < pair_num; p++)
   {
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        for (int n = 0; n < cnum[j]; n++)
        {
             double a = sqrt((pointt[i][m][1] - pointt[j][n][1]) * (pointt[i][m][1] - pointt[j][n][1]) +
                             (pointt[i][m][0] - pointt[j][n][0]) * (pointt[i][m][0] - pointt[j][n][0]));
             double b = sqrt((points[i][1] - points[j][1]) * (points[i][1] - points[j][1]) + 
                             (points[i][0] - points[j][0]) * (points[i][0] - points[j][0]));
             double c = a/b;
             fprintf(fd, "+%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
        }
        
        fprintf(fd, "- ss - u%d,%d + v%d,%d= 0\n", pair[p][0], pair[p][1], pair[p][0], pair[p][1]);
   }

   for(int p = 0; p < pair_num; p++)
   {
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        for (int n = 0; n < cnum[j]; n++)
        {
             double c = 0.5 * sqrt(areat[m]/areas[i]) +  0.5 * sqrt(areat[n]/areas[j]);
             fprintf(fd, "+%f x%d,%d,%d,%d\n", c, pair[p][0], m+1, pair[p][1],n+1);
        }

        fprintf(fd, "- ss  - aa%d,%d + bb%d,%d= 0\n", pair[p][0], pair[p][1], pair[p][0], pair[p][1]);
  }

  float template_area = 0;
   for(int i = 0; i < spoint_num; i++)
       template_area += areas[i];

   for(int i = 0; i < spoint_num; i++)
   {
        for (int j = 0; j < cnum[i]; j++)
        {

                fprintf(fd, "+%f yy%d,%d\n", sqrt(areat[j]), i+1, j+1);
        }
   }

   fprintf(fd, "- %f ss - uu + vv= 0\n", sqrt(template_area));


   for(int p = 0; p < pair_num; p++)
   {
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        {
            for (int n = 0; n < cnum[j]; n++)
            {
               fprintf(fd, "+ x%d,%d,%d,%d\n", pair[p][0], m+1, pair[p][1],n+1);
            }
 
            fprintf(fd, "- yy%d,%d = 0\n", pair[p][0], m+1);
        }

        for (int n = 0; n < cnum[j]; n++)
        {  
           for (int m = 0; m < cnum[i]; m++)
           {
               fprintf(fd, "+ x%d,%d,%d,%d\n", pair[p][0], m+1, pair[p][1],n+1);
           }
           
           fprintf(fd, "- yy%d,%d = 0\n", pair[p][1], n+1);
        }
    }

   for(int i = 0; i < spoint_num; i++)
   {
        for (int j = 0; j < cnum[i]; j++)
        {

                fprintf(fd, "+ yy%d,%d ", i+1, j+1);
        }
        fprintf(fd, " = 1\n");
   }

   float vsin = atof(argv[4]);
   float vcos = atof(argv[5]);
   int vw1, vw2, vt1, vt2;
   if (vsin >= 0 && vcos >= 0)
   {
      fprintf(fd, "ww + tt = 1\n\n");
      vw1 = 0; vw2 = 1;
      vt1 = 0; vt2 = 1;
   }
   else if (vsin <= 0 && vcos >= 0)
   {
      fprintf(fd, "-ww + tt = 1\n\n");
      vw1 = -1; vw2 = 0;
      vt1 = 0; vt2 = 1;
   }
   else if (vsin >= 0 && vcos <= 0)
   {
      fprintf(fd, "ww - tt = 1\n\n");
      vw1 = 0; vw2 = 1;
      vt1 = -1; vt2 = 0;
   }
   else if (vsin <= 0 && vcos <= 0)
   {
      fprintf(fd, "-ww - tt = 1\n\n");
      vw1 = -1; vw2 = 0;
      vt1 = -1; vt2 = 0;
   }

   fprintf(fd, "Bounds\n");

   fprintf(fd, " %d =< ww <= %d\n", vw1, vw2);
   fprintf(fd, " %d =< tt <= %d\n", vt1, vt2);
   fprintf(fd, " 0.5 =< ss <= 2\n");


   fprintf(fd, "\nBinaries\n");
   for(int i = 0; i < spoint_num; i++)
   {
        for (int j = 0; j < cnum[i]; j++)
        {

                fprintf(fd, "yy%d,%d\n", i+1, j+1);
        }
   }

   
   fclose(fd);
 
    // Clean up
    for(int n = 0; n < pair_num; n ++)
    {
        delete[] pair[n];
    } 
    delete[] pair;

    for(int n = 0; n < spoint_num; n ++)
    {
        delete[] points[n];
    }
    delete[] points;

    for(int n = 0; n < spoint_num; n ++)
    {
        delete[] cost[n];
    }
    delete[] cost;
    delete[] cnum;  

    for(int n = 0; n < spoint_num; n ++)
    {       
       for(int m = 0; m < pt_num[n]; m ++)
       {
         delete[] pointt[n][m];
       }
       delete[] pointt[n];
    }
    delete[] pointt;
    delete[] pt_num;

     return 0;
}
 
